Option Explicit On
Option Strict Off

Imports System.Runtime.InteropServices

Module MAI2088

    ' Device status (Return codes)
    Public Const MAI2088_OK As Integer = 0
    Public Const MAI2088_INVALID_HANDLE As Integer = 1
    Public Const MAI2088_DEVICE_NOT_FOUND As Integer = 2
    Public Const MAI2088_DEVICE_NOT_OPENED As Integer = 3
    Public Const MAI2088_OTHER_ERROR As Integer = 4
    Public Const MAI2088_COMMUNICATION_ERROR As Integer = 5
    Public Const MAI2088_OUT_OF_RANGE_PARAMETER As Integer = 6

    ' Constants
    Public Const MAI2088_LOW As Integer = 0
    Public Const MAI2088_HIGH As Integer = 1
    Public Const MAI2088_OFF As Integer = 0
    Public Const MAI2088_ON As Integer = 1
    Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL1 As Integer = 0
    Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL2 As Integer = 1
    Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL3 As Integer = 2
    Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL4 As Integer = 3
    Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL5 As Integer = 4
    Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL6 As Integer = 5
    Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL7 As Integer = 6
    Public Const MAI2088_ENCODER_SENSITIVITY_LEVEL8 As Integer = 7

    ' Function definitions
    Public Declare Function MAI2088_getNumberOfDevices Lib "MAI2088.dll" (ByRef number As Integer) As Integer
    Public Declare Function MAI2088_getSerialNumber Lib "MAI2088.dll" (ByVal index As Integer, ByRef serialNumber As Integer) As Integer
    Public Declare Function MAI2088_open Lib "MAI2088.dll" (ByRef handle As System.IntPtr) As Integer
    Public Declare Function MAI2088_openBySerialNumber Lib "MAI2088.dll" (ByVal serialNumber As Integer, ByRef handle As System.IntPtr) As Integer
    Public Declare Function MAI2088_close Lib "MAI2088.dll" (ByVal handle As System.IntPtr) As Integer
    Public Declare Function MAI2088_initialize Lib "MAI2088.dll" (ByVal handle As System.IntPtr) As Integer
    Public Declare Function MAI2088_getVersion Lib "MAI2088.dll" (ByVal handle As System.IntPtr, ByRef version As Integer) As Integer
    Public Declare Function MAI2088_getAnalogInputValue Lib "MAI2088.dll" (ByVal handle As System.IntPtr, ByVal index As Integer, ByRef value As Integer) As Integer
    Public Declare Function MAI2088_getDigitalInputState Lib "MAI2088.dll" (ByVal handle As System.IntPtr, ByVal index As Integer, ByRef state As Integer) As Integer
    Public Declare Function MAI2088_getDigitalOutputState Lib "MAI2088.dll" (ByVal handle As System.IntPtr, ByVal index As Integer, ByRef state As Integer) As Integer
    Public Declare Function MAI2088_setDigitalOutputState Lib "MAI2088.dll" (ByVal handle As System.IntPtr, ByVal index As Integer, ByVal state As Integer) As Integer
    Public Declare Function MAI2088_getPotentiometerValue Lib "MAI2088.dll" (ByVal handle As System.IntPtr, ByVal index As Integer, ByRef value As Integer) As Integer
    Public Declare Function MAI2088_setEncoderSensitivity Lib "MAI2088.dll" (ByVal handle As System.IntPtr, ByVal index As Integer, ByVal level As Integer) As Integer
    Public Declare Function MAI2088_getEncoderPulse Lib "MAI2088.dll" (ByVal handle As System.IntPtr, ByVal index As Integer, ByRef pulseCount As Integer) As Integer
    Public Declare Function MAI2088_getSwitchState Lib "MAI2088.dll" (ByVal handle As System.IntPtr, ByVal index As Integer, ByRef state As Integer) As Integer
    Public Declare Function MAI2088_setLEDState Lib "MAI2088.dll" (ByVal handle As System.IntPtr, ByVal index As Integer, ByVal state As Integer) As Integer
    Public Declare Function MAI2088_setLEDBrightness Lib "MAI2088.dll" (ByVal handle As System.IntPtr, ByVal index As Integer, ByVal brightness As Integer) As Integer
    Public Declare Function MAI2088_setLEDBlink Lib "MAI2088.dll" (ByVal handle As System.IntPtr, ByVal index As Integer, ByVal frequency As Double, ByVal dutyCycle As Integer, ByVal blinkCount As Integer) As Integer
    Public Declare Function MAI2088_set7SegmentLED Lib "MAI2088.dll" (ByVal handle As System.IntPtr, ByVal activeType As Integer, ByVal displayCharactor As Byte, ByVal dotPoint As Integer) As Integer

End Module
